;***************
; SU_CTCB.ASM
;***************
; 2013-11-10
; t@C
; ꕔ
;
; 2013-07-14
; 쐬


; }CNbPʂł̏
CTC0_US		EQU	64
CTC1_US		EQU	16384
INT_US		EQU	16666


;***************
;MUL16X8
;
;IN: A,HL
;OUT: HL
;DEST: AF,BC
;
;HL * A
;***************

MUL16X8:
	PUSH	HL
	POP		BC
	LD		HL,0000H

MUL16X8_LP:
	SRL		A
	JR		NC,MUL16X8_NC
	ADD		HL,BC
MUL16X8_NC:
	OR		A
	RET		Z

	SLA		C
	RL		B
	JR		MUL16X8_LP

;***************
;CP_HLBC
;
;OUT: C = 1 if HL > BC
;     Z = 1 if HL == BC
;
;DEST : AF
;***************

CP_HLBC:
	LD		A,B
	CP		H
	RET		NZ	; C=1 if B < H
	LD		A,C
	CP		L
	RET			; C=1 if C < L


;***************
;荞ݏ
;***************

; 荞݃C

USRINT_CTC:
	; CTC0 

	LD		HL,(CTC0CNT)
	LD		BC,INT_US
	ADD		HL,BC		;Ԍo߂Z
	LD		(CTC0CNT),HL

	; CTC1 
	LD		HL,(CTC1CNT)
	LD		BC,INT_US
	ADD		HL,BC		;Ԍo߂Z
	LD		(CTC1CNT),HL

	RET


;***************
;C̏
;***************
DO_CTC:

CTC0_LP:
	LD		HL,(CTC0CNT)
	LD		BC,(CTC0CST)

	; CTC0CNT >= CTC0CSTȂ犄荞ݏs
	CALL	CP_HLBC
	JR		Z,CTC0_INT
	JR		C,CTC0_INT
	
	LD		(CTC0CNT),HL
	JR		CTC0_END

CTC0_INT:
	; 莞ԌoĂ̂ŃJE^ZA荞݌Ăяo
	OR		A
	SBC		HL,BC
	LD		(CTC0CNT),HL

	CALL	INTRPT

	JR		CTC0_LP

CTC0_END:

	; CTC0Ƃقړl̏
CTC1_LP:
	LD		HL,(CTC1CNT)
	LD		BC,CTC1_US  ; CTC1͌Œ

	CALL	CP_HLBC
	JR		Z,CTC1_INT
	JR		C,CTC1_INT

	LD		(CTC1CNT),HL
	JR		CTC1_END

CTC1_INT:
	OR		A
	SBC		HL,BC
	LD		(CTC1CNT),HL

	CALL	INT2

	JR		CTC1_LP

CTC1_END:

	RET


CTC0CNT:
	DW	0000H

CTC0CST:
	DW	0000H

CTC1CNT:
	DW	0000H



